#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LONG 100

int fr;
char dernierpsset[LONG];

// recopie du texte plac entre les chaines debut et fin
void extraire_texte(char debut[],char fin[],FILE *source,FILE *dest)
{
	char cmd[LONG],ligne[LONG];		// allocation : char *toto = (char*)malloc(256);
		
	fputs(debut,dest);
	while (((fgets(ligne,LONG,source)) != NULL) && (!(strstr(ligne,fin))))
		{
		fputs (ligne , dest);
		}
	if (strstr(ligne,fin))
		{
		fputs (ligne , dest);
		}
}


void creer_image(char ligne[],char fin[],FILE *source,char dest[])
{
	FILE *ficimg;
	char cmd[LONG],nomficimg[LONG];
     
	sprintf(nomficimg,"%s.tex",dest);
	if ((ficimg = fopen(nomficimg,"w")) == NULL)
		{
		printf("Impossible de crer les fichiers d'images\n");
		exit(1);
		}
	// cration du prambule du document
	fputs("\\documentclass{article}\n",ficimg);
	fputs("\\usepackage{pst-eps}\n",ficimg);
	if (fr)
		{
		fputs("\\usepackage[fr]{psfig}\n",ficimg);
		}
	else
		{
		fputs("\\usepackage{psfig}\n",ficimg);
		}
	fputs("\\usepackage[T1]{fontenc}\n",ficimg);
	fputs("\\usepackage[french]{babel}\n",ficimg);
	fputs("\\usepackage{graphics}\n",ficimg);
	fputs("\\begin{document}\n",ficimg);
	fputs("\\TeXtoEPS\n",ficimg);
	
	if (dernierpsset)
		{
		fputs(dernierpsset,ficimg);
		}
	
	extraire_texte(ligne,fin,source,ficimg);

	fputs("\\endTeXtoEPS\n",ficimg);
	fputs("\\end{document}",ficimg);
	fclose(ficimg);

	// compilation du fichier image
	sprintf(cmd,"latex -interaction=batchmode %s",nomficimg);
	system(cmd);
	sprintf(cmd,"dvips -E -o %s.eps %s.dvi",dest,dest);
	system(cmd);
	sprintf(cmd,"epstopdf %s.eps",dest);
	system(cmd);
}


int main(int argc, char *argv[])
{
	FILE *fichier, *fictmp;
	char ligne[LONG],chainedebut[30],chainefin[30],cmd[LONG],tmp[LONG];
	char nomficimgsansext[LONG];
	int num=0,packgraph=0;

	if (argc>2)
		{// argument optionnel fr
		fr=1;
		sprintf(chainedebut,"\\begin{graphique}");
		sprintf(chainefin,"\\end{graphique}\n");
		}
	else
		{// pstricks normal
		fr=0;
		sprintf(chainedebut,"\\begin{pspicture");
		sprintf(chainefin,"\\end{pspicture");
		}

	if ((fichier=fopen(argv[1],"r")) == NULL)
		{
		printf("Impossible de lire le fichier source !\n");
		exit(1);
		}
	else
		{
		if ((fictmp=fopen("fictmp.tex","w")) == NULL)
			{
			printf("Impossible de crer le fichier de transfert !\n");
			exit(1);
			}
        	else
			while (fgets(ligne,LONG,fichier) != NULL)
				{
				// ajout de \usepackage{graphics} dans le document
				if ((!packgraph) && strstr(ligne,"\\begin{document}"))
					{
					fputs("\\usepackage{graphics}",fictmp);
					fputs(ligne,fictmp);
					}
				else
					if (strstr(ligne,"\\psset"))
						{
						strcpy(dernierpsset,ligne);
						}
					else
						if (strstr(ligne,chainedebut))
							{
							// cration du fichier image
							num++;
							sprintf(nomficimgsansext,"img%d",num);
							creer_image(ligne,chainefin,fichier,nomficimgsansext);
							// inclusion dans le fichier de transfert
							sprintf(ligne,"\\includegraphics{%s}",nomficimgsansext);
							fputs(ligne,fictmp);
							}
						else
							{
							fputs (ligne , fictmp);
							}
				}
		fclose(fictmp);
		// compilation du fichier de transfert
		system("pdflatex fictmp.tex");
		strncpy(tmp,argv[1],(int)(strchr(argv[1],'.')-argv[1]));
		sprintf(cmd,"mv fictmp.pdf %s.pdf",tmp);
		system(cmd);
		// nettoyage du chantier
		// sous Linux
		sprintf(cmd,"rm fictmp* img*");
		// sous Windows
		//sprintf(cmd,"del fictmp* img*");
		system(cmd);
		}
	fclose(fichier);
	return 0;
}
